public class KoncertnaDvorana {
	
	boolean[] sedista;
	
	ZaradaDvorane zaradaDvorane = new ZaradaDvorane();
	
	KoncertnaDvorana(int kapacitetSale) {
		if (kapacitetSale <= 0 ) {
			kapacitetSale = 120;
			System.out.println("Greska pri unosu kapacitate sale");
		}
		sedista = new boolean[kapacitetSale];
		
		//postavljamo da su sva sedista inicijalno prazna
		for (int i = 0; i < sedista.length; i++) {
			sedista[i] = true;
		}
	}
	
	void uvediGledaocaNaSediste(int brojSedista) {
		if ( brojSedista >= 0 && brojSedista < sedista.length && sedista[brojSedista] == true ) {
			sedista[brojSedista] = false;
			System.out.println("Gledalac je uveden na sediste br. " + brojSedista);
		}
	}
	
	void izracunajZaraduDvorane() {
		
		int zarada = 0;
		int granicnik = sedista.length/2;
				
		for (int i = 0; i < sedista.length; i++) {
			if ( sedista[i] == false ) { //mesto je zauzeto
				if ( i < granicnik ) 
					zarada += 500; //sediste iz 1. polovine sale
				else
					zarada += 250; //sediste iz 2. polovine sale
			}
		}
		
		zaradaDvorane.zarada = zarada;
		System.out.println("Zarada dvorane je: " + zarada);
		
	}
	
	boolean triSusednaSlobodna() {
		
		//spoljna for petlja omogucuje prolaz kroz niz sedista na nivou jednog reda, 
		//tj. pri jednom prolasku kroz ovu petlju razmatraju se sva sedista (ukupno 10) u jednom redu 
		for (int i = 0; i < sedista.length; i+=10) {
			//u okviru unutrasnje petlje trazimo 3 susedna slobodna mesta u jednom redu, polazeci od i-tog mesta;
			//brojac petlje j uzima vrednosti do i+8 (a ne i+10) jer pri svakom prolasku kroz petlju, pored 
			//j-tog elementa, razmatramo i naredna 2 (na pozicijama j+1 i j+2)
			for (int j = i; j < i + 8; j++) {
				if ( sedista[j] == true && sedista[j+1] == true && sedista[j+2] == true )
					return true; //nasli smo tri uzastopna slobodna sedista
			}
		}
		//ako metoda pri izvrsavanju dodje do ove linije, znaci da ni pri jednom prolasku kroz petlju
		//nisu pronadjena 3 uzastopna slobodna sedista (tj. uslov u gornjoj if naredbi se nikad nije izracunao u true) 
		return false;
	}

}
