public class OsvetljenjeSportskeHale {
	
	boolean[] sijalice;
	static final int SNAGA_SIJALICE = 330;
	
	OsvetljenjeSportskeHale(int ukupnoSijalica) {
		if ( ukupnoSijalica <= 0 ) 
			ukupnoSijalica = 100;
		
		sijalice = new boolean[ukupnoSijalica];
	}
	
	boolean sveSijaliceSuUpaljene() {
		for (int i = 0; i < sijalice.length; i++) {
			//ako nadjemo bar jednu sijalicu koja je ugasena, 
			//to znaci da nisu sve sijalice upaljene i metoda vraca vrednost false
			if ( sijalice[i] == false ) return false;
		}
		
		//ukoliko smo prosli kroz sve elemente niza, i ni za jedan
		//nismo utvrdili da ima vrednost false (tj. ni jedna sijalica nije ugasena)
		//metoda vraca vrednost true
		return true;
	}
	
	void upaliJednuSijalicu() {
		//prvo proveravamo da li su sve sijalice vec upaljene koristeci prethodno napisanu metodu
		if ( sveSijaliceSuUpaljene() ) {
			System.out.println("Sve sijalice su vec upaljene; ne moze se upaliti ni jedna nova sijalica");
			return;
		}
		
		//racunamo kolika je snaga trenutno upaljenih sijalica
		int ukupnaSnaga = 0;
		for (int i = 0; i < sijalice.length; i++) {
			if ( sijalice[i] == true ) 
				ukupnaSnaga += SNAGA_SIJALICE;
		}
		
		//ukoliko je ukupna snaga upaljenih sijalica manja od 10 000, 
		//upalicemo prvu koja je ugasena
		if ( ukupnaSnaga <= 10000 ) {
			//nadji prvu sijalicu koja je ugasena i upali je
			for (int i = 0; i < sijalice.length; i++) {
				if ( sijalice[i] == false ) {
					sijalice[i] = true;
					return;
				}
			}
		}
	}
	
	void upaliPoDijagonali(boolean[] milionSijalica) {
		//prvo gasimo sve sijalice
		for (int i = 0; i < milionSijalica.length; i++) {
			milionSijalica[i] = false;
		}
		
		//sad upali one koje su na dijagonali i to tako sto pri svakom 
		//prolasku kroz petlju brojac petlje (i) uvecavamo za 1001; 
		//razlog je to sto se na dijagonali nalaze sijalice tj. elementi niza 
		//sa indeksima 0, 1001, 2002, 3003, ... 
		for (int i = 0; i < milionSijalica.length; i+= 1001) {
			milionSijalica[i] = true;
		}
	}

}
