public class OsvetljenjeSportskeHale {
	
	boolean[] sijalice = new boolean[150];
	Osigurac osiguracOsvetljenja;
	
	OsvetljenjeSportskeHale(int snagaOsiguraca) {
		//prvo kreiramo objekat klase Osigurac (inicijalizacija) 
		osiguracOsvetljenja = new Osigurac();
		//zatim, dodeljujemo vrednost njegovom atributu snaga
		if ( snagaOsiguraca > 0 )
			osiguracOsvetljenja.snaga = snagaOsiguraca;
		else
			osiguracOsvetljenja.snaga = 5000;
	}
	
	void upaliSvakuDruguSijalicu() {
		//pri svakom prolasku kroz petlju, brojac petlje (i)
		//se uvecava za 2 jer hocemo da upalimo svaku drugu sijalicu
		for (int i = 0; i < sijalice.length; i+=2) {
			sijalice[i] = true;
		}
	}
	
	void upaliSijaliceRedom() {
		//lokalna promenljiva koja predstavlja snagu jedne sijalice
		//za prvih 100 sijalica, snaga je 100 (posle cemo je promeniti za preostalih 50 sijalica)
		int snagaSijalice = 100;
		//lokalna promenljiva koja predstavlja ukupnu snagu svih upaljenih sijalica
		int ukupnaSnaga = 0;
		
		int i = 0;
		//sve dok je ukupna snaga svih upaljenih sijalica manja od snage osiguraca
		//palimo jednu po jednu sijalicu
		while (ukupnaSnaga <= osiguracOsvetljenja.snaga) {
			sijalice[i] = true; 
			//prvih 100 sijalica je snage 100, preostalih 50 je snage 200
			//ukoliko smo 'prosli' prvih 100, menjamo snagu sijalice na 200 
			if ( i == 100 ) snagaSijalice = 200;
			ukupnaSnaga += snagaSijalice;
			i++;
		}
	}
	
	void upaliSijaliceNaObodu() {
		//prvo gasimo sve sijalice
		for (int i = 0; i < sijalice.length; i++) {
			sijalice[i] = false;
		}
		
		//sad palimo prvi red (u jednom redu ima 10 sijalica)
		for (int i = 0; i < 10; i++) {
			sijalice[i] = true;
		}
		
		//zatim, poslednji red; indeksi sijalica u poslednjem redu 
		//se  krecu u opsegu od 140 do 149
		for (int i = 140; i < 150; i++) {
			sijalice[i] = true;
		}
		
		//zatim, sijalice duz leve ivice;
		//prva i poslednja sijalica duz ove ivice su vec upaljene;
		//indeks petlje uvecavamo za 10 da bi pri svakom prolasku 
		//kroz petlj upresli u naredni red
		for (int i = 10; i < 140; i+=10) {
			sijalice[i] = true;
		}
		
		//na kraju, sijalice duz desne ivice;
		//prva i poslednja sijalica duz ove ivice su vec upaljene;
		//indeks petlje uvecavamo za 10 da bi pri svakom prolasku 
		//kroz petlj upresli u naredni red
		for (int i = 19; i < 149; i+=10) {
			sijalice[i] = true;
		}
	}

}
