public class TezineClanovaEkipe {
	
	double[] tezineBoksera = new double[20];
	int brojClanova = 0;
	static final int MIN_TEZINA = 40;
	
	TezineClanovaEkipe() {
		for (int i = 0; i < tezineBoksera.length; i++) {
			tezineBoksera[i] = -1;
		}
	}
	
	void dodajNovogClana(double tezina) {
		//niz nije popunjen ukoliko je trenutni broj elemenata niza (brojClanova)
		//manji od maksimalnog broja elemenata niza (tezineBoksera.length)
		if ( brojClanova < tezineBoksera.length && tezina >= MIN_TEZINA ) {
			tezineBoksera[brojClanova] = tezina; //upisujemo novi element na prvu slobodnu poziciju u nizu
			brojClanova += 1; //uvecavamo broj elemenata niza za jedan
		} else
			System.out.println("Greska! Tezina novog clana nije dodata u niz");
	}
	
	void prikaziDistribucijuPoKategorijama() {
		//lokalne promenljive u kojima cemo cuvati broj boksera u svakoj od kategorija
		int brojLaka = 0, brojSrednja = 0, brojTeska = 0;
		
		//prolazimo kroz sve elemente niza i zavisno od vrednosti elementa
		//(tj. tezine boksera) uvecavamo za jedan odgovarajucu lokalnu promenljivu
		for (int i = 0; i < brojClanova; i++) {
			if ( tezineBoksera[i] < 65 ) brojLaka += 1;
			else if ( tezineBoksera[i] < 85 ) brojSrednja += 1;
			else brojTeska += 1; //tezina je >= 85		
		}
		
		//racunamo procentualnu zastupljenost svake od tezinskih kategorija;
		//pri tome, broj boksera odredjene kategorije mnozimo sa 100.0 (a ne sa 100) 
		//kako bi dobili double vrednost i time obezbedili 'pravo' deljenje 
		//tj. izbegli celobrojno deljenje koje se primenjuje kad su i deljenik i delilac int vrednosti 
		double procenatLaka = (brojLaka * 100.0)/brojClanova;
		double procenatSrednja = (brojSrednja * 100.0)/brojClanova;
		double procenatTeska = (brojTeska * 100.0)/brojClanova;
		
		System.out.println("Lakoj kategoriji pripada " + procenatLaka + "% boksera");
		System.out.println("Sredjoj kategoriji pripada " + procenatSrednja + "% boksera");
		System.out.println("Teskoj kategoriji pripada " + procenatTeska + "% boksera");
	}

	static double[] vratiDruguEkipu(double[] tezine3Ekipe) {
		//indeks elementa niza koji odvaja tezine 1. ekipe of tezina 2. ekipe
		int prviGranicnik = 0;
		//indeks elementa niza koji odvaja tezine 2. ekipe of tezina 3. ekipe
		int drugiGranicnik = 0;
		//brojac elemenata niza koji predstavljaju tezine 2. ekipe
		int brojac = 0;
		
		//prvo pronalazimo poziciju prvog 'granicnog' elementa
		for (int i = 0; i < tezine3Ekipe.length; i++) {
			if ( tezine3Ekipe[i] == -1 ) {
				prviGranicnik = i;
				break; //kad smo pronasli 1. granicnik, izlazimo iz petlje
			}
		}
		
		//zatim, pronalazimo poziciju drugog 'granicnog' elementa;
		//krecemo od elementa niza koji se nalazi neposredno nakon prvog granicnika
		for (int i = prviGranicnik + 1; i < tezine3Ekipe.length; i++) {
			if ( tezine3Ekipe[i] == -1 ) {
				drugiGranicnik = i;
				break; //kad smo pronasli 2. granicnik, izlazimo iz petlje
			} else
				brojac += 1; //tezine 2. ekipe se nalaze izmedju 1. i 2. granicnika
							//tako da koristimo ovu petlju da odredimo broj clanova 2. ekipe
		}
		
		//kreiramo novi niz koji cemo vratiti kao povratnu vrednost metode;
		//taj niz ce imati onoliko elemenata koliko smo utvrdili da ima clanova 2. ekipe
		double[] noviNiz = new double[brojac];
		//indeks elemenata novog niza
		int j = 0;
		//krecemo od prvog elementa nakon 1. granicnika i uzimamo jedan po jedan element 
		//niza tezine3Ekipe sve dok ne dodjemo do 2. granicnika
		for (int i = prviGranicnik + 1; i < drugiGranicnik; i++) {
			noviNiz[j] = tezine3Ekipe[i];
			j++;
		}
		
		return noviNiz;
	}
}
