public class TezineClanovaEkipe {
	
	double[] tezineBoksera;
	int brojClanova = 0;
	TipEkipe kategorija;
	
	TezineClanovaEkipe(int maxClanova, char oznakaKategorije) {	
		kategorija = new TipEkipe();
		kategorija.tezinskaKategorija = oznakaKategorije;
		
		if ( maxClanova <= 0 )
			maxClanova = 20;
		tezineBoksera = new double[maxClanova];	
	}
	
	void prikaziStatistike() {
		//ukupna tezina svih boksera u ekipi;
		//potrebna za racunanje prosecne tezine
		double ukupnaTezina = 0;
		
		//prolazimo kroz sve elemente niza i racunamo ukupnu tezinu
		//atribut brojClanova sadrzi trenutni broj elemenata u nizu
		for (int i = 0; i < brojClanova; i++) {
			ukupnaTezina += tezineBoksera[i];
		}
		
		double prosecnaTezina = ukupnaTezina/brojClanova;
		
		int brojIznadProseka = 0;
		int brojIspodProseka = 0;
		//prolazimo kroz sve elemente niza i uporedjujemo vrednost svakog elementa niza
		//sa izracunatom prosecnom vrednoscu kako bi odredili broj onih koji su iznad i ispod proseka
		for (int i = 0; i < brojClanova; i++) {
			if ( tezineBoksera[i] < prosecnaTezina ) brojIspodProseka++;
			else if ( tezineBoksera[i] > prosecnaTezina ) brojIznadProseka++;
		}
		
		System.out.println("Prosecna tezina boksera u ekipi je: " + prosecnaTezina);
		System.out.println("Broj boksera sa tezinom iznad proseka je: " + brojIznadProseka);
		System.out.println("Broj boksera sa tezinom ispod proseka je: " + brojIspodProseka);
	}
	
	void dodajNovogClana(double tezina) {
		//proveravamo da li je trenutni broj elemenata niza (brojClanova) manji od maksimalnog (tezineBoksera.length)
		//i da li je uneta tezina u granicama (pozivom pomocne metode)
		if ( brojClanova < tezineBoksera.length && tezinaJeUGranicama(tezina) ) {
			tezineBoksera[brojClanova] = tezina;
			brojClanova++;
		}
	}
	
	/**
	 * Pomocna metoda namenjena proveri da li je odredjena tezina u granicama propisanim 
	 * za svaku tezinsku kategoriju
	 * @param tezina tezina za koju se proverava da li je u granicama
	 * @return ukoliko je tezina u propisanim granicama, metoda vraca true, u suprotnom false 
	 */
	boolean tezinaJeUGranicama(double tezina) {
		if ( kategorija.tezinskaKategorija == 'L' && tezina >= 45 && tezina < 65 ) return true;
		if ( kategorija.tezinskaKategorija == 'S' && tezina >= 65 && tezina < 85 ) return true;
		if ( kategorija.tezinskaKategorija == 'T' && tezina >= 85 ) return true;
		//u svim ostalim slucajevima, metoda vraca false
		return false;
	}
	
	static boolean postojeLi2BokseraIsteTezine(double[] ekipa1, double[] ekipa2) {
		
		boolean par1Nadjen = false;
		
		for (int i = 0; i < ekipa1.length; i++) {
			//za jedan element niza ekipa1, prolazimo kroz elemente niza ekipa2 
			//i trazimo element sa istom vrednoscu 
			for (int j = 0; j < ekipa2.length; j++) {
				if ( ekipa1[i] == ekipa2[j] ) { //nasli smo par elemenata sa istom vrednoscu
					if ( !par1Nadjen ) { //ukoliko do sad nismo nasli ni jedan par elemenata sa istom vrednoscu
						par1Nadjen = true; //postavljamo indikaciju da je prvi takav par nadjen
						break; //prekidamo unutrasnju petlju
					} else {
						//prvi par je vec nadjen, a sad je nadjen i drugi par
						//metoda vraca true jer smo nasli 2 para sa istim tezinama
						return true;
					}
				}
			}
		}
		//metoda vraca false jer ili nije pronadjen ni jedan par koji se poklapa
		//ili je nadjen samo jedan par
		return false;
	}

}
