public class NizOcena {
	
	char[] ocene = new char[30];
	int brojOcena = 0;
	static final char OCEKIVANA_OCENA = 'B';
	
	NizOcena() {
		for (int i = 0; i < ocene.length; i++) {
			ocene[i] = 'N';
		}
	}
	
	void unesiNovuOcenu(char ocena) {
		//ocena se unosi ako je trenutni broj elemenata niza (brojOcena) manji od 
		//maksimalnog broja (ocene.length) i ako je uneta ocena validna (provera preko pomocne metode)
		if ( brojOcena < ocene.length && ocenaJeValidna(ocena) ){
			ocene[brojOcena] = ocena;
			brojOcena++;
		} else {
			System.out.println("Nastupila je greska, ocena nije upisana");
		}
	}
	
	/**
	 * Pomocna metoda za utvrdjivanje da li je ocena validna tj. da li ocena 
	 * odgovara jednoj od dozvoljenih vrednosti
	 * @param ocena ocena za koju se proverava ispravnost
	 * @return metoda vraca true ukoliko je ocena validna, u suprotnom vraca false 
	 */
	boolean ocenaJeValidna(char ocena) {
		//niz validnih vrednosti za ocene
		char[] okOcene = {'A', 'B', 'C', 'D', 'E', 'F'};
		//prolazimo kroz niz validnih ocena i pokusavamo da utvrdimo da li 
		//uneta ocena odgovara nekoj od ocena iz niza
		for (int i = 0; i < okOcene.length; i++) {
			if ( ocena == okOcene[i] )
				return true; //utvrdili smo da je uneta ocena jednaka jednoj od validnih ocena
							//i metoda prekida sa radom i vraca vrednost true
		}
		//ako prodjemo kroz sve validne ocene i ne utvrdimo jednakost ni sa jednom od njih
		//metoda vraca false kao svoju povratnu vrendnost
		return false;
	}
	
	boolean postignutaJeOcekivanaOcena() {
		//broj djaka sa ocekivanom ocenom
		int brojOcekivanaOcena = 0;
		//broj djaka sa svim ostalim ocenama
		int brojOstali = 0;
		
		for (int i = 0; i < brojOcena; i++) {
			if ( ocene[i] == OCEKIVANA_OCENA ) brojOcekivanaOcena++;
			else brojOstali++;
		}
		
		if (brojOcekivanaOcena > brojOstali) return true;
		else return false; //else ovde nije obavezno
	}
	
	static void prikaziBrojOcenaA(char[] oceneOdeljenja) {
		
		//spoljna for petlja koja ima za cilj da omoguci 'prolaz' kroz niz na nivou odeljenja, 
		//tj. pri jednom prolasku kroz petlju razmatraju se ocene svih djaka (ukupno 30) u jednom odeljenju 
		for (int i = 0; i < oceneOdeljenja.length; i+=30) {
			//broj djaka sa ocenom A u i-tom odeljenju
			int brojOcenaA = 0;
			//unutrasnja for petlja koja omogucuje prolazak kroz sve ocene jednog odeljenja  
			for (int j = i; j < i+30; j++) {
				if (oceneOdeljenja[j] == 'A') brojOcenaA++;
			}
			System.out.println("U odeljenju br." + (i/30+1) + " ima " + brojOcenaA + " djaka sa ocenom A");
		}
	}
}
