public class NizOcena {
	
	char[] ocene;
	int brojOcena = 0;
	Statistika statistikaOdeljenja = new Statistika();
	
	NizOcena(int maxBrojDjaka) {
		if ( maxBrojDjaka <= 0 ) {
			System.out.println("Pogresno uneta vrednost za max broj ocena; koristice se default vrednost 25");
			maxBrojDjaka = 25;
		}	
		ocene = new char[maxBrojDjaka];
	}
	
	void unesiNovuOcenu(char ocena) {
		//ocena se unosi ako je trenutni broj elemenata niza (brojOcena) manji od 
		//maksimalnog broja (ocene.length) i ako je uneta ocena validna (provera preko pomocne metode)
		if ( brojOcena < ocene.length && ocenaJeValidna(ocena) ) {
			ocene[brojOcena] = ocena;
			brojOcena++;
		} else {
			System.out.println("Greska pri unosu ocene; ocena nije uneta");
		}
	}
	
	/**
	 * Pomocna metoda za utvrdjivanje da li je ocena validna tj. da li ocena 
	 * odgovara jednoj od dozvoljenih vrednosti
	 * @param ocena ocena za koju se proverava ispravnost
	 * @return metoda vraca true ukoliko je ocena validna, u suprotnom vraca false 
	 */
	boolean ocenaJeValidna(char ocena) {
		//ako je ulazni argument jednak bilo kojoj od vrednosti iz skupa {'A', 'B', 'C', 'D', 'N'}
		//izraz u zagradi se izracunava u true; ukoliko ulazni argument nije jednak ni jednoj 
		//od vrednosti iz navedenog skupa, izraz se izracunava u false 
		return ( ocena == 'A' || ocena == 'B' || ocena == 'C' || ocena == 'D' || ocena == 'N' );	
	}
	
	void prikaziBrojSvakeOcene() {
		int brojA = 0, brojB = 0, brojC = 0, brojD = 0, brojN = 0;
		
		for (int i = 0; i < brojOcena; i++) {
			switch (ocene[i]) {
				case 'A': brojA++; break;
				case 'B': brojB++; break;
				case 'C': brojC++; break;
				case 'D': brojD++; break;
				default: brojN++;
			}
		}
		
		System.out.println("Broj ucenika sa ocenom A: " + brojA);
		System.out.println("Broj ucenika sa ocenom B: " + brojB);
		System.out.println("Broj ucenika sa ocenom C: " + brojC);
		System.out.println("Broj ucenika sa ocenom D: " + brojD);
		System.out.println("Broj ucenika sa ocenom N: " + brojN);
		
		int brojPrelaznihOcena = brojOcena - brojN;
		//brojPrelaznihOcena mnozimo sa 100.0 (a ne sa 100) jer hocemo da dobijemo double
		//vrednost i tako osiguramo 'pravo' deljenje (ako su i deljenik i delilac int vrednosti
		//vrsi se celobrojno deljenje)
		statistikaOdeljenja.procenatProlaznosti = (brojPrelaznihOcena * 100.0)/brojOcena;
	}
	
	static boolean postojiOdeljeSviNedovoljni(char[] oceneOdeljenja) {
		
		//spoljna for petlja koja ima za cilj da omoguci 'prolaz' kroz niz na nivou odeljenja, 
		//tj. pri jednom prolasku kroz ovu petlju razmatraju se ocene svih djaka (ukupno 25) u jednom odeljenju 
		for (int i = 0; i < oceneOdeljenja.length; i+=25) {
			//broj djaka sa ocenom N u i-tom odeljenju
			int brojNedovoljnih = 0;
			//unutrasnja for petlja omogucuje prolazak kroz sve ocene jednog odeljenja  
			for (int j = 0; j < j+25; j++) {
				if ( oceneOdeljenja[j] != 'N' )  //ako smo naisli na ocenu koja nije N, znaci da u tom odeljenju nisu svi nedovoljni;
					break;						//prekidamo izvrsavanje petlje jer nam to odelje vise nije interesantno	
				else brojNedovoljnih++;					
			}
			if ( brojNedovoljnih == 25 ) return true; //nasli smo odeljenje u kome su svi nedovoljni; metoda prekida sa radom i vraca true
		}
		//nismo nasli odeljenje u kome su svi nedovoljni 
		return false;
	}

}
