public class LizingKompanija {
	
	double[] odobreniLizing = new double[1000];
	int brojOdobrenih = 0;
	
	void unesiNoviIznosLizinga(double iznos) {
		if ( brojOdobrenih < odobreniLizing.length && iznos > 0 && iznos < 2000000 ) {
			odobreniLizing[brojOdobrenih] = iznos;
			brojOdobrenih++;
		} else {
			System.out.println("Greska! Novi lizing nije registrovan kao odobren");
		}
	}
	
	void prikaziMesecneRateOdorenihLizinga() {
		//brojac petlje
		int i = 0;
		//petlja prolazi kroz sve elemente niza; broj elemenata niza je zapisan u atributu brojOdobrenih
		while( i < brojOdobrenih ) {
			int godOtplate;
			//rok otplate na svakom petom mestu je 6 god; u ostalim slucajevima je 3 god
			//proveravamo da li je u pitanju 5. mesto tako sto gledamo da li je ostatak pri celobrojnom deljenju sa 5 jedak 0
			//s obizrom da brojac petlje krece od 0, onda ga uvecamo za 1 pre racunanja ostatka pri deljenu sa 5 
			if ( (i+1) % 5 == 0 )
				godOtplate = 6;
			else
				godOtplate = 3;
			//pozivamo metodu iz klase LizingKalkulator za racunanje mesecne rate; metoda je deklarisana kao static metoda
			//tako da je pozivamo direktno preko klase (ne objekta)
			double mesecnaRata = LizingKalkulator.izracunajMesecnuRatu(odobreniLizing[i], godOtplate);
			System.out.println("Mesecna rata za odobreni lizing od " + odobreniLizing[i] + " dinara, iznosi " + mesecnaRata + " dinara");
			System.out.println("god. otplate: " + godOtplate);
			i++;
		}
	}
	
	static boolean postojeLiIstiIznosi(double[] lizing1, double[] lizing2) {
		//indikator koji ukazuje da li je nadjen jedan (prvi) par istih vrednosti u dva ulazna niza 
		boolean postoji1 = false;
		
		for (int i = 0; i < lizing1.length; i++) {
			for (int j = 0; j < lizing2.length; j++) {
				if ( lizing1[i] == lizing2[j] ) {
					if ( !postoji1 ) { //ukoliko jos nije nadjen ni jedan par istih vrednosti
						postoji1 = true; //postavljamo indikaciju da smo sad nasli prvi zajednicki par
						break;	//prekidamo unutrasnju petlju
					} else { //ovo znaci da je jedan par vec bio nadjen (postoji1 == true), sad je nadjen i drugi zajednicki par
						return true; //posto su nadjena dva para istih vrednosti, metoda prekida sa radom i vraca true
					}
				}
			}
		}
		//ako program dodje dovde, znaci da nismo nasli dva ista iznosa
		return false;
	}

}
