public class Banka {
	
	int[] krediti;
	int brojKredita = 0;
	
	Banka(int maxKredita) {
		krediti = new int[maxKredita];
		for (int i = 0; i < krediti.length; i++) {
			krediti[i] = 0;
		}
	}
	
	void unesiNoviKredit(int iznosKredita) {
		if ( brojKredita < krediti.length && iznosKredita > 0 ) {
			krediti[brojKredita] = iznosKredita;
			brojKredita++;
		} else {
			System.out.println("Greska! Novi kredit nije evidentiran");
		}
	}
	
	double izracunajProsecnuMesecnuRatu() {	
		//ukupna mesecna rata za sve kredite vece od 10000
		double ukupnaMesecnaRata = 0;
		//brojac kredita koji su vec od 10000
		int brojac = 0;
		
		for (int i = 0; i < brojKredita; i++) {
			if ( krediti[i] > 10000 ) {
				//racunamo mesecnu ratu po datoj formuli i koristeci kamatnu stopu zapisanu u konstanti KAMATNA_STOPA klase PolitikaBanke 
				double rata = (krediti[i] * (100 + PolitikaBanke.KAMATNA_STOPA))/(100*12);
				ukupnaMesecnaRata += rata;
				brojac++;
			}
		}
		if ( brojac > 0 ) //sprecavamo situaciju deljenja nulom u slucajevima kada ne postoji ni jedan kredit > 10000
			return ukupnaMesecnaRata/brojac;
		else
			return 0; 
	}
	
	static void prikaziBankuSaNajvecimKreditom(int[] kreditiBanaka) {
		//ukupni krediti za svaku od 3 banke
		int banka1Ukupno = 0, banka2Ukupno = 0, banka3Ukupno = 0;
		
		//indeks elementa niza koji predstavlja 'granicnik' izmedju elemenata 1. banke i elemenata 2. banke
		//inicijalno postavljamo da taj indeks bude -1 (vrednost koju ni jedan elemet niza ne moze imati)
		int granicnik1 = -1;
		//indeks elementa niza koji predstavlja 'granicnik' izmedju elemenata 2. banke i elemenata 3. banke
		int granicnik2 = -1;
		
		//prolazimo kroz niz kreditiBanaka kako bi odredili pozicije dva granicnika
		for (int i = 0; i < kreditiBanaka.length; i++) {
			if ( kreditiBanaka[i] == -1 ) { //naisli smo na jedan granicnik, treba da vidimo koji 
				if ( granicnik1 < 0 )  //ukoliko vrednost za granicnik1 jos nije bila postavljena (jos je -1)
					granicnik1 = i;  //postavljamo da je granicnik1 jednak indeksu elementa za koji smo utvrdili da ima vrednost -1
				else { 				//u suprotnom, ako je granicnik1 vec bio postavljen tj. vec ima dodeljenu vrednost
					granicnik2 = i;	//postavljamo da je granicnik2 jednak indeksu elementa za koji smo utvrdili da ima vrednost -1
					break; //nasli smo oba granicnika i nije potrebno da se petlja dalje vrti
				}
			}
		}
		
		//racunamo ukupan iznos kredita banke 1
		//to su krediti od prve pozicije u nizu kreditiBanaka do pozicije 1. granicnika
		for (int i = 0; i < granicnik1; i++) {
			banka1Ukupno += kreditiBanaka[i];
		}
		
		//racunamo ukupan iznos kredita banke 2
		//to su krediti tj. elementi niza kreditiBanaka izmedju dva granicnika
		for (int i = granicnik1+1; i < granicnik2; i++) {
			banka2Ukupno += kreditiBanaka[i];
		}
		
		//racunamo ukupan iznos kredita banke 3
		//to su krediti tj. elementi niza kreditiBanaka od 2. granicnika (ne uzimajuci granicnik) pa do kraja niza
		for (int i = granicnik2+1; i < kreditiBanaka.length; i++) {
			banka3Ukupno += kreditiBanaka[i];
		}
		
		//utvrdjujemo i ispisujemo koja banka ima najvise odobrenih kredita 
		if ( banka1Ukupno > banka2Ukupno && banka1Ukupno > banka3Ukupno )
			System.out.println("Banka 1");
		else if ( banka2Ukupno > banka1Ukupno && banka2Ukupno > banka3Ukupno )
			System.out.println("Banka 2");
		else System.out.println("Banka 3");
	}
		
		

}
