public class Avion {
	
	boolean[] sedistaEkonomska;
	boolean[] sedistaPoslovna;
	
	Avion(int brojEkonomskih, int brojPoslovnih) {
		if ( brojEkonomskih < 0 || brojPoslovnih < 0 ) {
			brojEkonomskih = 120;
			brojPoslovnih = 60;
			System.out.println("Greska pri unosu broja mesta u avionu");
		}
		
		sedistaEkonomska = new boolean[brojEkonomskih];
		//postavljamo da sva sedista ekonomske klase inicijalno budu slobodna
		for (int i = 0; i < sedistaEkonomska.length; i++) {
			sedistaEkonomska[i] = true;
		}
		
		sedistaPoslovna = new boolean[brojPoslovnih];
		//postavljamo da sva sedista poslovne klase inicijalno budu slobodna
		for (int i = 0; i < sedistaPoslovna.length; i++) {
			sedistaPoslovna[i] = true;
		}
	}
	
	void uvediPutnika(boolean poslovnaKlasa, int brojSedista) {
		//ukoliko ulazni parametar poslovnaKlasa ima vrednost true, uvodimo putnika u poslovnu klasu
		if ( poslovnaKlasa ) { 	
			//proveravamo da li je mesto na zadatoj poziciji slobodno
			if ( sedistaPoslovna[brojSedista] == true ) 
				sedistaPoslovna[brojSedista] = false;	//zauzimamo sediste 
			else 
				System.out.println("Greska! Sediste je vec zauzeto");
		} else { //ulazni parametar poslovnaKlasa ima vrednost false, tako da uvodimo putnika u ekonomsku klasu
			//proveravamo da li je mesto na zadatoj poziciji slobodno
			if ( sedistaEkonomska[brojSedista] == true )
				sedistaEkonomska[brojSedista] = false; //zauzimamo sediste
			else
				System.out.println("Greska! Sediste je vec zauzeto");
		}
	}
	
	void prikaziIzvestajOLetu() {
		int brojZauzetihEkonomska = 0;
		int brojZauzetihPoslovna = 0;
		
		for (int i = 0; i < sedistaEkonomska.length; i++) {
			if ( sedistaEkonomska[i] == false ) brojZauzetihEkonomska++;
		}
		
		for (int i = 0; i < sedistaPoslovna.length; i++) {
			if ( sedistaPoslovna[i] == false ) brojZauzetihPoslovna++;
		}
		
		double zauzetostEkonomska = 0;
		//ovu proveru uvodimo da se ne bi desilo da delimo sa nulom kad avion nema ekonomskih sedista
		if ( sedistaEkonomska.length > 0 )
			zauzetostEkonomska = (brojZauzetihEkonomska * 100.0)/sedistaEkonomska.length;
		double zauzetostPoslovna = 0;
		//ovu proveru uvodimo da se ne bi desilo da delimo sa nulom kad avion nema poslovnih sedista
		if (sedistaPoslovna.length > 0 )
			zauzetostPoslovna = (brojZauzetihPoslovna * 100.0)/sedistaPoslovna.length;
		
		int prihod = brojZauzetihEkonomska * 250 + brojZauzetihPoslovna * 500;
		
		System.out.println("U ekonomskoj klasi zauzeto je " + zauzetostEkonomska + "% sedista");
		System.out.println("U poslovnoj klasi zauzeto je " + zauzetostPoslovna + "% sedista");
		System.out.println("Ukupan prihod od prodatih karata je " + prihod);
	}
	
	boolean triSlobodnaUEkonomskoj() {
		
		//spoljna for petlja omogucuje prolaz kroz niz sedistaEkonomska na nivou jednog reda, 
		//tj. pri jednom prolasku kroz ovu petlju razmatraju se sva sedista (ukupno 6) u jednom redu  
		for (int i = 0; i < sedistaEkonomska.length; i+=6) {
			//u okviru unutrasnje petlje trazimo 3 susedna slobodna mesta u jednom redu, polazeci od i-tog mesta
			//brojac petlje j uzima vrednosti do i+4 (a ne i+6) jer pri svakom prolasku kroz petlju, pored 
			//j-tog elementa, razmatramo i naredna 2 (na pozicijama j+1 i j+2)
			for (int j = i; j < i+4; j++) {
				if ( sedistaEkonomska[j] == sedistaEkonomska[j+1] == sedistaEkonomska[j+2] == true ) 
					return true; //nasli smo tri uzastopna slobodna sedista
			}
		}
		//ako metoda pri izvrsavanju dodje do ove linije, znaci da ni pri jednom prolasku kroz petlju
		//nisu pronadjena 3 uzastopna slobodna mesta (tj. uslov u gornjoj if naredbi se nikad nije izracunao u true) 
		return false; 
	}

}
