public class Trajekt {
	
	boolean[] sedistaIMesta;
	int ukupanBrojSedista;
	
	Trajekt(int brojSedista, int brojMesta) {
		if ( brojSedista < 0 || brojMesta < 0 ) {
			brojSedista = 0;
			brojMesta = 120;
			System.out.println("Greska pri unosu broja sedista i/ili mesta za automobile");
		}
		
		ukupanBrojSedista = brojSedista;
		sedistaIMesta = new boolean[ brojSedista + brojMesta ];
		//postavljamo da sva sedista i mesta inicijalno budu slobodna
		for (int i = 0; i < sedistaIMesta.length; i++) {
			sedistaIMesta[i] = true;
		}
	}
	
	void uvediAutoNaTrajekt(int brojMesta) {
		//posto se u nizu mesta za automobile nalaze posle sedista za putnike, 
		//onda se pozicija na koju treba uvesti automobil dobija tako sto na broj sedista 
		//za putnike dodamo redni broj mesta na koji hocemo da uvedemo automobil
		if ( sedistaIMesta[ ukupanBrojSedista + brojMesta ] == true ) 
			sedistaIMesta[ ukupanBrojSedista + brojMesta ] = false;
		else
			System.out.println("Greska! Mesto je vec zauzeto");
	}
	
	void prikaziIzvestajOTrajektu() {
		int brojZauzetihSedista = 0;
		int brojZauzetihMesta = 0;
		
		//u nizu se sedista za putnike nalaze od 0-te pozicije do pozicije ukupanBrojSedista - 1
		for (int i = 0; i < ukupanBrojSedista; i++) {
			if ( sedistaIMesta[i] == false ) brojZauzetihSedista++;
		}
		
		//u nizu se mesta za kola nalaze od pozicije ukupanBrojSedista do poslednje pozicije niza
		for (int i = ukupanBrojSedista; i < sedistaIMesta.length; i++) {
			if ( sedistaIMesta[i] == false ) brojZauzetihMesta++;
		}
		
		int brojSlobodnihSedista = ukupanBrojSedista - brojZauzetihSedista;
		
		int ukupanBrojMesta = sedistaIMesta.length - ukupanBrojSedista;
		int brojSlobodnihMesta = ukupanBrojMesta - brojZauzetihMesta;
		
		double procenatZauzetihSedista = 0;
		//ovu proveru uvodimo da se ne bi desilo da delimo sa nulom kad trajekt nema sedista za putnike
		if ( ukupanBrojSedista > 0 )
			procenatZauzetihSedista = (brojZauzetihSedista * 100.0)/ukupanBrojSedista;
		
		double procenatZauzetihMesta = 0;
		//ovu proveru uvodimo da se ne bi desilo da delimo sa nulom kad trajekt nema mesta za automobile
		if ( ukupanBrojMesta > 0 )
			procenatZauzetihMesta = (brojZauzetihMesta * 100.0 )/ukupanBrojMesta;
		
		boolean putSeIsplati = procenatZauzetihSedista > 66 && procenatZauzetihMesta > 45;
		
		System.out.println("Podaci o trajektu:");
		System.out.println("- broj slobodnih sedista: " + brojSlobodnihSedista);
		System.out.println("- broj zauzetih sedista: " + brojZauzetihSedista);
		System.out.println("- broj slobodnih mesta za automobile: " + brojSlobodnihMesta);
		System.out.println("- broj zauzetih mesta za automobile: " + brojZauzetihMesta);
		if ( putSeIsplati )
			System.out.println("Put se isplati");
		else 
			System.out.println("Put se NE isplati");
	}
	
	boolean imaLiMestaZaAutobus() {
		
		//brojac i uzima vrednosti do sedistaIMesta.length - 4 zato sto pri svakom prolasku kroz petlju
		//pored i-tog elementa, razmatramo i naredna 4 elementa
		for (int i = ukupanBrojSedista; i < sedistaIMesta.length - 4; i++) {
			//broj uzastopnih slobodnih mesta
			int brojSlobodnih = 0;
			//razmatramo i-ti i naredna 4 elementa niza; interesuje nas 5 povezanih sa vrednoscu true
			for (int j = i; j < i + 5; j++) {
				if ( sedistaIMesta[j] == true ) brojSlobodnih++;
			}
			if ( brojSlobodnih == 5 ) return true; //nasli smo 5 uzastopnih slobodnih mesta
		}
		//ako metoda pri izvrsavanju dodje do ove linije, znaci da ni pri jednom prolasku kroz petlju
		//nije pronadjeno 5 uzastopnih slobodnih mesta (tj. brojSlobodnih ni jednom nije bio 5) 	
		return false;
	}

}
