public class ZavodZaTransfuzijuKrvi {
	
	char[] donacije;
	int brojDonacija = 0;
	static final int MINIMALNA_REZERVA = 5000;
	
	ZavodZaTransfuzijuKrvi() {
		donacije = new char[1000];
		for (int i = 0; i < donacije.length; i++) {
			donacije[i] = 'N';
		}
	}
	
	void unesiNovuDonaciju(char krvnaGrupa) {
		//donacija krvi se unosi ako je trenutni broj elemenata niza (brojDonacija) manji od 
		//maksimalnog broja (donacije.length) i ako je uneta oznaka krvne grupe validna (provera preko pomocne metode)
		if ( brojDonacija < donacije.length && krvnaGrupaOK(krvnaGrupa) ) {
			donacije[brojDonacija] = krvnaGrupa;
			brojDonacija++;
			return;
		} 
		if ( brojDonacija >= donacije.length )
			System.out.println("Zavod nema vise mesta za skladistenje");
		if ( !krvnaGrupaOK(krvnaGrupa) )
			System.out.println("Pogresna krvna grupa");
	}
	
	/**
	 * Pomocna metoda za utvrdjivanje da li je oznaka krvne grupe validna tj. da li oznaka  
	 * krvne grupe odgovara jednoj od dozvoljenih vrednosti
	 * @param krvnaGrupa oznaka krvne grupe za koju se proverava ispravnost
	 * @return metoda vraca true ukoliko je oznaka krvne grupe validna, u suprotnom vraca false 
	 */
	boolean krvnaGrupaOK(char krvnaGrupa) {
		//ako je ulazni argument jednak bilo kojoj od vrednosti iz skupa {'A', 'B', 'O', 'M'}
		//izraz u zagradi se izracunava u true; ukoliko ulazni argument nije jednak ni jednoj 
		//od vrednosti iz navedenog skupa, izraz se izracunava u false 
		return ( krvnaGrupa == 'A' || krvnaGrupa == 'B' || krvnaGrupa == 'O' || krvnaGrupa == 'M' );
	}
	
	void ispisiPodatkeODonacijama() {
		
		int brojA = 0, brojB = 0, brojO = 0, brojM = 0;
		
		for (int i = 0; i < brojDonacija; i++) {
			switch (donacije[i]) {
				case 'A': brojA++; break;
				case 'B': brojB++; break;
				case 'O': brojO++; break;
				default: brojM++; break;
			}
		}
		
		//prikaz podataka o donacijama za svaku od krvnih grupa 
		//koristi se pomocna metoda da bi se izbeglo ponavljanje istog koda
		prikaziPodatkeOKrvnojGrupi('A', brojA);
		prikaziPodatkeOKrvnojGrupi('B', brojB);
		prikaziPodatkeOKrvnojGrupi('O', brojO);
		prikaziPodatkeOKrvnojGrupi('M', brojM);
		
	}
	
	/**
	 * Pomocna metoda za prikaz podataka o donacijama krvi za datu krvnu grupu
	 * @param krvnaGrupa krvna grupa za koju se prikazuju podaci 
	 * @param brojKrvGrupa broj donacija za tu krvnu grupu
	 */
	void prikaziPodatkeOKrvnojGrupi(char krvnaGrupa, int brojKrvGrupa) {	
		double procenat = (brojKrvGrupa * 100.0)/brojDonacija;
		System.out.println("Krvna grupa " + krvnaGrupa + ":");
		System.out.println("- broj donacija: " + brojKrvGrupa);
		System.out.println("- procenat zastupljenosti: " + procenat);
		if ( brojKrvGrupa < MINIMALNA_REZERVA )
			System.out.println("Krvna grupa " + krvnaGrupa + " je deficitarna!");
		System.out.println("--------------------------------------");
	}
	
	void dopuniNizDonacija(char[] noveDonacije) {
		//broj slobodnih mesta u nizu
		int brojSlobodnih = donacije.length - brojDonacija;
		
		if ( brojSlobodnih >= noveDonacije.length ) {
			//ima dovoljno mesta da se sve nove donacije smeste u niz; nove donacije
			//se upisuju u niz polazeci od prve slobodne pozicije u nizu (brojDonacija)
			for (int i = 0; i < noveDonacije.length; i++) {
				donacije[ brojDonacija ] = noveDonacije[i];
				brojDonacija++;
			}
		} else { //prebacujemo samo donacije krvnih grupa O i A
			for (int i = 0; i < noveDonacije.length; i++) {
				if ( (noveDonacije[i] == 'A' || noveDonacije[i] == 'O') && brojDonacija < donacije.length ) {
					donacije[ brojDonacija ] = noveDonacije[i];
					brojDonacija++;
				}
			}
		}
	}

}
