public class PsiholoskoTestiranje {
	
	char[] oznakeLicnosti = new char[Licnosti.MAX_BROJ_UCESNIKA];
	int brojUnetih = 0;
	
	void unesiNovuOznaku(char oznakaLicnosti) {
		//oznaka tipa licnosti se unosi ako je trenutni broj elemenata niza (brojUnetih) manji od 
		//maksimalnog broja (oznakeLicnosti.length) i ako je uneta oznaka tipa licnosti validna (provera preko pomocne metode)
		if ( brojUnetih < oznakeLicnosti.length && oznakaLicnostiOK(oznakaLicnosti) ) {
			oznakeLicnosti[ brojUnetih ] = oznakaLicnosti;
			brojUnetih++;
			//pozivamo static metodu iz klase Licnosti za prikaz unetog tipa licnosti
			Licnosti.prikaziTipLicnosti(oznakaLicnosti);
		} else 
			System.out.println("Greska! Nova oznaka licnosti nije evidentirana");
	}
		
	/**
	 * Pomocna metoda za utvrdjivanje da li je oznaka tipa licnosti validna tj. da li oznaka  
	 * odgovara jednoj od dozvoljenih vrednosti
	 * @param oznaka oznaka tipa licnosti za koju se proverava ispravnost
	 * @return metoda vraca true ukoliko je oznaka tipa licnosti validna, u suprotnom vraca false 
	 */
	boolean oznakaLicnostiOK(char oznaka) {
		return (oznaka == 'S' || oznaka == 'F' || oznaka == 'M' || oznaka == 'K');
	}
	
	void prikaziNajzastupljenijiTip() {
		int brojS = 0, brojK = 0, brojF = 0, brojM = 0;
		
		//uzimamo svaki treci element niza
		for (int i = 0; i < brojUnetih; i+=3) {
			switch (oznakeLicnosti[i]) {
			case 'S': brojS++; 
				break;
			case 'K': brojK++;
				break;
			case 'F': brojF++;
				break;
			default: brojM++;
				break;
			}
		}
		
		//utvrdjujemo koji tip licnosti je najzastupljeniji
		int max = brojS;
		char maxOznaka = 'S';
		if ( brojK > max ) {
			max = brojK; maxOznaka = 'K';
		}
		if ( brojM > max ) {
			max = brojM; maxOznaka = 'M';
		}
		if ( brojF > max ) {
			max = brojF; maxOznaka = 'F';
		}
		
		System.out.print("Na osnovu uzetog uzorka, najvise ima osoba sa tipom licnosti: ");
		Licnosti.prikaziTipLicnosti(maxOznaka);
	}
	
	void prikaziElementeNizaNaizmenicno() {
		//koristimo 2 brojaca: 
		//- brojac i omogucuje kretanje od 1. elementa niza, do elementa koji se nalazi na polovini niza; 
		//- brojac j omogucuje kretanje od poslednjeg elementa niza do onog koji je na sredini niza 
		for (int i = 0, j = brojUnetih - 1; i < brojUnetih/2; i++, j--) {
			Licnosti.prikaziTipLicnosti( oznakeLicnosti[i] );
			Licnosti.prikaziTipLicnosti( oznakeLicnosti[j] );
		}
		//ako je broj elemenata u nizu paran, svi elementi niza ce biti ispisani u prethodnoj for petlji;
		//ako je broj elemenata niza neparan, element na samoj sredini niza nece biti ispisan;
		//zato proveravamo da li je broj elemenata niza neparan, i ako jeste, ispisujemo 'sredisnji' elementa 
		if ( brojUnetih % 2 != 0 )
			Licnosti.prikaziTipLicnosti( oznakeLicnosti[ brojUnetih/2 ] );
	}

}
